class Cookies {
  constructor(tracker) {
    this.tracker = tracker;
    this.cookies = this.getCookies();
    this.order = 'after';
    return this;
  }

  getCookies() {
    const cookies = {};
    if (typeof document !== 'undefined') {
      const pairs = document.cookie.split(';');
      for (let i = 0; i < pairs.length; i += 1) {
        const pair = pairs[i].split('=');
        cookies[(pair[0]).trim()] = decodeURIComponent(pair[1]);
      }
    }
    return cookies;
  }

  callback(event) {
    event.data.cookies = this.getCookies();
    return event;
  }
}

export default Cookies;
