/**
 * Aynchronously send event information to the tracker URL
 * @function
 * @param {string} eventName
 * @param {string} eventCategory
 * @param {string} eventAction
 * @param {string} eventOrigin
 * @param {string} [eventLabel] = ''
 * @param {string} [eventValue] = ''
 * @param {string} [eventSchema] = 'latest'
 * @param {object} [data] = {} - Event object
 * @return {Promise}
 */
class GoogleAnalytics {
  callback(thisEvent) {
    window.dataLayer = window.dataLayer || [];
    const gaData = Object.assign(
      {
        event: thisEvent.eventName,
        eventCategory: thisEvent.data.eventCategory,
        eventAction: thisEvent.data.eventAction,
        eventValue: thisEvent.data.eventValue,
        eventLabel: thisEvent.data.eventLabel,
        eventSchema: thisEvent.eventSchema,
        eventTimestamp: thisEvent.eventTimestamp,
        eventUuid: thisEvent.eventUuid,
        eventOrigin: thisEvent.eventOrigin,
      },
      thisEvent.data,
    );
    window.dataLayer.push(gaData);
    return thisEvent;
  }
}

export default GoogleAnalytics;
